diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/Biomes.java b/game/core/src/main/java/net/minecraft/core/world/biome/Biomes.java
index 8fd5abe0a..e42bbc5d1 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/Biomes.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/Biomes.java
@@ -11,28 +11,28 @@ import net.minecraft.core.world.weather.Weathers;
 public class Biomes
 {
 
-    public static final Biome OVERWORLD_RAINFOREST = register("minecraft:overworld.rainforest", new BiomeRainforest("overworld.rainforest").setColor(0x1cf100).setBlockedWeathers(Weathers.OVERWORLD_SNOW));
-    public static final Biome OVERWORLD_SWAMPLAND = register("minecraft:overworld.swampland", new BiomeSwamp("overworld.swampland").setColor(0x00ff78));
-    public static final Biome OVERWORLD_SEASONAL_FOREST = register("minecraft:overworld.seasonal_forest", new BiomeSeasonalForest("overworld.seasonal_forest").setColor(0x64ce15));
-    public static final Biome OVERWORLD_FOREST = register("minecraft:overworld.forest", new BiomeForest("overworld.forest").setColor(0x26a615));
-    public static final Biome OVERWORLD_GRASSLANDS = register("minecraft:overworld.grasslands", new Biome("overworld.grasslands").setColor(0xf0f048).setBlockedWeathers(Weathers.OVERWORLD_SNOW));
-    public static final Biome OVERWORLD_OUTBACK = register("minecraft:overworld.outback", new BiomeOutback("overworld.outback").setColor(0xd95e20).setBlockedWeathers(Weathers.OVERWORLD_SNOW).setTopBlock(Blocks.DIRT_SCORCHED.id()).setFillerBlock(Blocks.DIRT_SCORCHED.id()));
-    public static final Biome OVERWORLD_SHRUBLAND = register("minecraft:overworld.shrubland", new BiomeShrubland("overworld.shrubland").setColor(0xbaba38));
-    public static final Biome OVERWORLD_TAIGA = register("minecraft:overworld.taiga", new BiomeTaiga("overworld.taiga").setColor(0x8abcff).setSurfaceSnow().setSurfaceIce());
-    public static final Biome OVERWORLD_BOREAL_FOREST = register("minecraft:overworld.boreal_forest", new BiomeBorealForest("overworld.boreal_forest").setColor(0x148564));
-    public static final Biome OVERWORLD_DESERT = register("minecraft:overworld.desert", new BiomeDesert("overworld.desert").setColor(0xEDE26F).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM).setTopBlock(Blocks.SAND.id()).setFillerBlock(Blocks.SAND.id()));
-    public static final Biome OVERWORLD_PLAINS = register("minecraft:overworld.plains", new BiomePlains("overworld.plains").setColor(0xA3C649));
-    public static final Biome OVERWORLD_GLACIER = register("minecraft:overworld.glacier", new Biome("overworld.glacier").setColor(0xcbf6ff).setSurfaceSnow().setTopBlock(Blocks.BLOCK_SNOW.id()).setFillerBlock(Blocks.BLOCK_SNOW.id()));
-    public static final Biome OVERWORLD_TUNDRA = register("minecraft:overworld.tundra", new Biome("overworld.tundra").setColor(0x57e0ff).setSurfaceSnow().setSurfaceIce());
-    public static final Biome OVERWORLD_MEADOW = register("minecraft:overworld.meadow", new BiomeBorealForest("overworld.meadow").setColor(0x8c8c22));
-    public static final Biome DRIFT_DRIFT = register("minecraft:drift.drift", new BiomeDrift("drift.drift").setColor(0x8080FF).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG));
-    public static final Biome OVERWORLD_BIRCH_FOREST = register("minecraft:overworld.birch_forest", new BiomeBirchForest("overworld.birch_forest").setColor(0x4bcb5e));
+    public static final Biome OVERWORLD_RAINFOREST = register("minecraft:overworld.rainforest", new BiomeRainforest("overworld.rainforest").setColor(0x1cf100).setBlockedWeathers(Weathers.OVERWORLD_SNOW).setDefaults(0.975f, 0.925f, 0.5f));
+    public static final Biome OVERWORLD_SWAMPLAND = register("minecraft:overworld.swampland", new BiomeSwamp("overworld.swampland").setColor(0x00ff78).setDefaults(0.85f, 0.925f, 0.5f));
+    public static final Biome OVERWORLD_SEASONAL_FOREST = register("minecraft:overworld.seasonal_forest", new BiomeSeasonalForest("overworld.seasonal_forest").setColor(0x64ce15).setDefaults(0.675f, 0.75f, 0.5f));
+    public static final Biome OVERWORLD_FOREST = register("minecraft:overworld.forest", new BiomeForest("overworld.forest").setColor(0x26a615).setDefaults(0.875f, 0.675f, 0.5f));
+    public static final Biome OVERWORLD_GRASSLANDS = register("minecraft:overworld.grasslands", new Biome("overworld.grasslands").setColor(0xf0f048).setBlockedWeathers(Weathers.OVERWORLD_SNOW).setDefaults(0.75f, 0.025f, 0.5f));
+    public static final Biome OVERWORLD_OUTBACK = register("minecraft:overworld.outback", new BiomeOutback("overworld.outback").setColor(0xd95e20).setBlockedWeathers(Weathers.OVERWORLD_SNOW).setTopBlock(Blocks.DIRT_SCORCHED.id()).setFillerBlock(Blocks.DIRT_SCORCHED.id()).setDefaults(0.825f, 0.1f, 0.5f));
+    public static final Biome OVERWORLD_SHRUBLAND = register("minecraft:overworld.shrubland", new BiomeShrubland("overworld.shrubland").setColor(0xbaba38).setDefaults(0.675f, 0.175f, 0.5f));
+    public static final Biome OVERWORLD_TAIGA = register("minecraft:overworld.taiga", new BiomeTaiga("overworld.taiga").setColor(0x8abcff).setSurfaceSnow().setSurfaceIce().setDefaults(0.15f, 0.55f, 0.5f));
+    public static final Biome OVERWORLD_BOREAL_FOREST = register("minecraft:overworld.boreal_forest", new BiomeBorealForest("overworld.boreal_forest").setColor(0x148564).setDefaults(0.4f, 0.525f, 0.5f));
+    public static final Biome OVERWORLD_DESERT = register("minecraft:overworld.desert", new BiomeDesert("overworld.desert").setColor(0xEDE26F).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM).setTopBlock(Blocks.SAND.id()).setFillerBlock(Blocks.SAND.id()).setDefaults(0.925f, 0.05f, 0.5f));
+    public static final Biome OVERWORLD_PLAINS = register("minecraft:overworld.plains", new BiomePlains("overworld.plains").setColor(0xA3C649).setDefaults(0.875f, 0.25f, 0.5f));
+    public static final Biome OVERWORLD_GLACIER = register("minecraft:overworld.glacier", new Biome("overworld.glacier").setColor(0xcbf6ff).setSurfaceSnow().setTopBlock(Blocks.BLOCK_SNOW.id()).setFillerBlock(Blocks.BLOCK_SNOW.id()).setDefaults(0.15f, 0.005f, 0.5f));
+    public static final Biome OVERWORLD_TUNDRA = register("minecraft:overworld.tundra", new Biome("overworld.tundra").setColor(0x57e0ff).setSurfaceSnow().setSurfaceIce().setDefaults(0.15f, 0.055f, 0.5f));
+    public static final Biome OVERWORLD_MEADOW = register("minecraft:overworld.meadow", new BiomeBorealForest("overworld.meadow").setColor(0x8c8c22).setDefaults(0.4f, 0.025f, 0.5f));
+    public static final Biome DRIFT_DRIFT = register("minecraft:drift.drift", new BiomeDrift("drift.drift").setColor(0x8080FF).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG).setDefaults(0.5f, 0.0f, 0.0f));
+    public static final Biome OVERWORLD_BIRCH_FOREST = register("minecraft:overworld.birch_forest", new BiomeBirchForest("overworld.birch_forest").setColor(0x4bcb5e).setDefaults(0.675f, 0.4f, 0.5f));
     public static final Biome OVERWORLD_RETRO = register("minecraft:overworld.retro", new BiomeRetro("overworld.retro").setColor(0x76B14A).setTopBlock(Blocks.GRASS_RETRO.id()));
     public static final Biome OVERWORLD_HELL = register("minecraft:overworld.hell", new Biome("overworld.hell").setColor(0xD96223).setTopBlock(Blocks.DIRT_SCORCHED.id()).setTopBlock(Blocks.DIRT_SCORCHED.id()));
-    public static final Biome OVERWORLD_SWAMPLAND_MUDDY = register("minecraft:overworld.swampland.muddy", new BiomeSwamp("overworld.swampland.muddy").setColor(0x522700));
-    public static final Biome OVERWORLD_OUTBACK_GRASSY = register("minecraft:overworld.outback.grassy", new BiomeOutback("overworld.outback.grassy").setColor(0xf09037).setBlockedWeathers(Weathers.OVERWORLD_SNOW).setTopBlock(Blocks.GRASS_SCORCHED.id()).setFillerBlock(Blocks.DIRT_SCORCHED.id()));
-    public static final Biome OVERWORLD_CAATINGA = register("minecraft:overworld.caatinga", new BiomeCaatinga("overworld.caatinga").setColor(0xdecda6).setTopBlock(Blocks.MUD_BAKED.id()).setFillerBlock(Blocks.MUD_BAKED.id()).setBlockedWeathers(Weathers.OVERWORLD_SNOW));
-    public static final Biome OVERWORLD_CAATINGA_PLAINS = register("minecraft:overworld.caatinga.plains", new Biome("overworld.caatinga.plains").setColor(0xa19477).setTopBlock(Blocks.MUD_BAKED.id()).setFillerBlock(Blocks.MUD_BAKED.id()).setBlockedWeathers(Weathers.OVERWORLD_SNOW));
+    public static final Biome OVERWORLD_SWAMPLAND_MUDDY = register("minecraft:overworld.swampland.muddy", new BiomeSwamp("overworld.swampland.muddy").setColor(0x522700).setDefaults(0.85f, 0.925f, 0.5f));
+    public static final Biome OVERWORLD_OUTBACK_GRASSY = register("minecraft:overworld.outback.grassy", new BiomeOutback("overworld.outback.grassy").setColor(0xf09037).setBlockedWeathers(Weathers.OVERWORLD_SNOW).setTopBlock(Blocks.GRASS_SCORCHED.id()).setFillerBlock(Blocks.DIRT_SCORCHED.id()).setDefaults(0.825f, 0.1f, 1.0f));
+    public static final Biome OVERWORLD_CAATINGA = register("minecraft:overworld.caatinga", new BiomeCaatinga("overworld.caatinga").setColor(0xdecda6).setTopBlock(Blocks.MUD_BAKED.id()).setFillerBlock(Blocks.MUD_BAKED.id()).setBlockedWeathers(Weathers.OVERWORLD_SNOW).setDefaults(0.95f, 0.015f, 0.5f));
+    public static final Biome OVERWORLD_CAATINGA_PLAINS = register("minecraft:overworld.caatinga.plains", new Biome("overworld.caatinga.plains").setColor(0xa19477).setTopBlock(Blocks.MUD_BAKED.id()).setFillerBlock(Blocks.MUD_BAKED.id()).setBlockedWeathers(Weathers.OVERWORLD_SNOW).setDefaults(0.95f, 0.015f, 0.0f));
     public static final Biome NETHER_NETHER = register("minecraft:nether.nether", new BiomeNether("nether.nether").setColor(0xDD0000).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG).setTopBlock(Blocks.COBBLE_NETHERRACK.id()).setFillerBlock(Blocks.COBBLE_NETHERRACK.id()));
     public static final Biome NETHER_VOLCANIC_ISLANDS = register("minecraft:nether.volcanic_islands", new BiomeVolcanoIslands("nether.volcanic_islands").setColor(0xDD0000).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG).setTopBlock(Blocks.COBBLE_NETHERRACK.id()).setFillerBlock(Blocks.COBBLE_NETHERRACK.id()));
     public static final Biome NETHER_SULFUR_POOLS = register("minecraft:nether.sulfur_pools", new BiomeSulfurPools("nether.sulfur_pools").setColor(0xDD0000).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG).setTopBlock(Blocks.COBBLE_NETHERRACK.id()).setFillerBlock(Blocks.COBBLE_NETHERRACK.id()));
@@ -40,16 +40,16 @@ public class Biomes
     public static final Biome NETHER_ASH_PLAINS = register("minecraft:nether.ash_plains", new BiomeAshPlains("nether.ash_plains").setColor(0xDD0000).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG).setTopBlock(Blocks.SLATE.id()).setFillerBlock(Blocks.SLATE.id()));
     public static final Biome NETHER_BONEYARD = register("minecraft:nether.boneyard", new BiomeBoneyard("nether.boneyard").setColor(0xDD0000).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG).setTopBlock(Blocks.SOULSAND.id()).setFillerBlock(Blocks.SOULSAND.id()));
 
-    public static final Biome OVERWORLD_LEGACY_RAINFOREST = register("minecraft:overworld.legacy.rainforest", new BiomeRainforestLegacy("overworld.legacy.rainforest").setColor(0xd9e023).setBlockedWeathers(Weathers.OVERWORLD_SNOW));
-    public static final Biome OVERWORLD_LEGACY_SWAMPLAND = register("minecraft:overworld.legacy.swampland", new BiomeSwampLegacy("overworld.legacy.swampland").setColor(0x07f9b2));
-    public static final Biome OVERWORLD_LEGACY_SEASONAL_FOREST = register("minecraft:overworld.legacy.seasonal_forest", new Biome("overworld.legacy.seasonal_forest").setColor(0x9be023));
-    public static final Biome OVERWORLD_LEGACY_FOREST = register("minecraft:overworld.legacy.forest", new BiomeForestLegacy("overworld.legacy.forest").setColor(0x056621));
-    public static final Biome OVERWORLD_LEGACY_SAVANNA = register("minecraft:overworld.legacy.savanna", new BiomeDesertLegacy("overworld.legacy.savanna").setColor(0xd9e023).setBlockedWeathers(Weathers.OVERWORLD_SNOW));
-    public static final Biome OVERWORLD_LEGACY_SHRUBLAND = register("minecraft:overworld.legacy.shrubland", new Biome("overworld.legacy.shrubland").setColor(0xa1ad20));
-    public static final Biome OVERWORLD_LEGACY_TAIGA = register("minecraft:overworld.legacy.taiga", new BiomeTaigaLegacy("overworld.legacy.taiga").setColor(0x2eb153).setSurfaceSnow().setSurfaceIce());
-    public static final Biome OVERWORLD_LEGACY_DESERT = register("minecraft:overworld.legacy.desert", new BiomeDesertLegacy("overworld.legacy.desert").setColor(0xfa9418).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM).setTopBlock(Blocks.SAND.id()).setFillerBlock(Blocks.SAND.id()));
-    public static final Biome OVERWORLD_LEGACY_PLAINS = register("minecraft:overworld.legacy.plains", new BiomeDesertLegacy("overworld.legacy.plains").setColor(0xffd910));
-    public static final Biome OVERWORLD_LEGACY_TUNDRA = register("minecraft:overworld.legacy.tundra", new Biome("overworld.legacy.tundra").setColor(0x57ebf9).setSurfaceSnow().setSurfaceIce());
+    public static final Biome OVERWORLD_LEGACY_RAINFOREST = register("minecraft:overworld.legacy.rainforest", new BiomeRainforestLegacy("overworld.legacy.rainforest").setColor(0xd9e023).setBlockedWeathers(Weathers.OVERWORLD_SNOW).setDefaults(0.985f,  0.95f, 0.5f));
+    public static final Biome OVERWORLD_LEGACY_SWAMPLAND = register("minecraft:overworld.legacy.swampland", new BiomeSwampLegacy("overworld.legacy.swampland").setColor(0x07f9b2).setDefaults(0.75f, 0.4f, 0.5f));
+    public static final Biome OVERWORLD_LEGACY_SEASONAL_FOREST = register("minecraft:overworld.legacy.seasonal_forest", new Biome("overworld.legacy.seasonal_forest").setColor(0x9be023).setDefaults(0.985f, 0.675f, 0.5f));
+    public static final Biome OVERWORLD_LEGACY_FOREST = register("minecraft:overworld.legacy.forest", new BiomeForestLegacy("overworld.legacy.forest").setColor(0x056621).setDefaults(0.735f, 0.425f, 0.5f));
+    public static final Biome OVERWORLD_LEGACY_SAVANNA = register("minecraft:overworld.legacy.savanna", new BiomeDesertLegacy("overworld.legacy.savanna").setColor(0xd9e023).setBlockedWeathers(Weathers.OVERWORLD_SNOW).setDefaults(0.725f, 0.1f, 0.5f));
+    public static final Biome OVERWORLD_LEGACY_SHRUBLAND = register("minecraft:overworld.legacy.shrubland", new Biome("overworld.legacy.shrubland").setColor(0xa1ad20).setDefaults(0.735f, 0.275f, 0.5f));
+    public static final Biome OVERWORLD_LEGACY_TAIGA = register("minecraft:overworld.legacy.taiga", new BiomeTaigaLegacy("overworld.legacy.taiga").setColor(0x2eb153).setSurfaceSnow().setSurfaceIce().setDefaults(0.3f, 0.35f, 0.5f));
+    public static final Biome OVERWORLD_LEGACY_DESERT = register("minecraft:overworld.legacy.desert", new BiomeDesertLegacy("overworld.legacy.desert").setColor(0xfa9418).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM).setTopBlock(Blocks.SAND.id()).setFillerBlock(Blocks.SAND.id()).setDefaults(0.975f, 0.1f, 0.5f));
+    public static final Biome OVERWORLD_LEGACY_PLAINS = register("minecraft:overworld.legacy.plains", new BiomeDesertLegacy("overworld.legacy.plains").setColor(0xffd910).setDefaults(0.985f, 0.325f, 0.5f));
+    public static final Biome OVERWORLD_LEGACY_TUNDRA = register("minecraft:overworld.legacy.tundra", new Biome("overworld.legacy.tundra").setColor(0x57ebf9).setSurfaceSnow().setSurfaceIce().setDefaults(0.05f, 0.5f, 0.5f));
 
     public static Biome register(String key, Biome biome)
     {
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProvider.java b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProvider.java
index 42d548ae5..bd910ad9f 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProvider.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProvider.java
@@ -4,12 +4,20 @@ import com.mojang.logging.LogUtils;
 import it.unimi.dsi.fastutil.objects.Object2IntArrayMap;
 import it.unimi.dsi.fastutil.objects.Object2IntMap;
 import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
+import org.jetbrains.annotations.NotNull;
 import org.slf4j.Logger;
 
 public abstract class BiomeProvider {
     private static final Logger LOGGER = LogUtils.getLogger();
 
+    protected final @NotNull World world;
+
+    public BiomeProvider(final @NotNull World world) {
+        this.world = world;
+    }
+
     public Biome getBiome(final int x, final int y, final int z) {
         final Biome[] out = getBiomes(null, x, y, z, 1, 1, 1);
         return out[0];
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderB173.java b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderB173.java
index 6d95fd3a7..201b7c338 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderB173.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderB173.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.world.biome.provider;
 
+import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.noise.FractalNoise2D;
@@ -20,7 +21,11 @@ public class BiomeProviderB173
     private final @NotNull FractalNoise2D<?> downfallMap;
     private final @NotNull FractalNoise2D<?> noiseMap;
 
-    public BiomeProviderB173(final long seed) {
+    public BiomeProviderB173(final @NotNull World world) {
+        super(world);
+
+        final long seed = world.getRandomSeed();
+
         this.temperatureMap = new FractalNoise2D<>(SimplexNoise.genOctaves(seed * 9871, 4));
         this.downfallMap = new FractalNoise2D<>(SimplexNoise.genOctaves(seed * 39811, 4));
         this.noiseMap = new FractalNoise2D<>(SimplexNoise.genOctaves(seed * 543321, 4));
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java
index 0d03b4adb..8d0508689 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderNether.java
@@ -1,26 +1,20 @@
 package net.minecraft.core.world.biome.provider;
 
+import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.noise.FractalNoise2D;
 import net.minecraft.core.world.noise.FractalNoise3D;
 import net.minecraft.core.world.noise.SimplexNoise;
 import net.minecraft.core.world.type.WorldTypes;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Arrays;
 
 public final class BiomeProviderNether
     extends BiomeProvider
 {
-    public static class BiomeOverlapPair {
-        public boolean hasOverlap;
-        public Biome biomeA;
-        public Biome biomeB;
-        public float biomeAPercentage;
-        public float biomeBPercentage;
-    }
-
-    private static final Biome[] biomesOrder = {
+    public static final Biome[] BIOMES_ORDER = {
             Biomes.NETHER_BONEYARD,
             Biomes.NETHER_ASH_PLAINS,
             Biomes.NETHER_CRYSTAL_FOREST,
@@ -41,8 +35,11 @@ public final class BiomeProviderNether
     private double fuzzinessZScale = 0.25;
     private double fuzzinessLacunarity = 1.0;
 
-    public BiomeProviderNether(long seed)
+    public BiomeProviderNether(final @NotNull World world)
     {
+        super(world);
+
+        final long seed = world.getRandomSeed();
         this.temperatureNoise = new FractalNoise3D<>(SimplexNoise.genOctaves(seed * 5345, 4));
         this.fuzzinessNoise = new FractalNoise3D<>(SimplexNoise.genOctaves(seed * 35864, 2));
     }
@@ -79,7 +76,7 @@ public final class BiomeProviderNether
 
                 for (int dy = 0; dy < ySize; dy++)
                 {
-                    double altitude = WorldTypes.NETHER_DEFAULT.getYPercentage((y + dy) << 3);
+                    double altitude = WorldTypes.NETHER_DEFAULT.getYPercentage(world, (y + dy) << 3);
                     biomes[dy * xSize * zSize + dz * xSize + dx] = lookupBiome(temperature, humidity, altitude, variety);
                 }
             }
@@ -181,104 +178,16 @@ public final class BiomeProviderNether
 
     @Override
     public Biome lookupBiome(double temperature, double humidity, double altitude, double variety) {
-        for (int i = 0; i < biomesOrder.length; i++) {
-            if (temperature <= (1.0 / biomesOrder.length) * (i + 1)) {
-                return biomesOrder[i];
+        for (int i = 0; i < BIOMES_ORDER.length; i++) {
+            if (temperature <= (1.0 / BIOMES_ORDER.length) * (i + 1)) {
+                return BIOMES_ORDER[i];
             }
         }
 
         return Biomes.NETHER_NETHER;
     }
 
-    public void getOverlap(double temperature, BiomeOverlapPair toUpdate) {
-        final float overlapAmount = 1f / (float)(biomesOrder.length * 4);
-
-        for (int i = 0; i < biomesOrder.length; i++) {
-            // The *strict* bounds of the biome, as used by this::lookupBiome()
-            final float minStrict = (1.0f / biomesOrder.length) * i;
-            final float maxStrict = (1.0f / biomesOrder.length) * (i + 1);
-            // The outer bounds of the biome, i.e. strict bounds plus overlap amount. If in this range, guaranteed overlap
-            final float minOuter = minStrict - overlapAmount;
-            final float maxOuter = maxStrict + overlapAmount;
-            // The inner bounds of the biome, i.e. strict bounds minus overlap amount. If in this range, guaranteed no overlap
-            final float minInner = minStrict + overlapAmount;
-            final float maxInner = maxStrict - overlapAmount;
-
-            // Edge cases
-            if ((i == 0 && temperature < minInner) ||
-                (i == biomesOrder.length - 1 && temperature >= maxInner)
-            ) {
-                toUpdate.hasOverlap = false;
-                toUpdate.biomeA = biomesOrder[i];
-                toUpdate.biomeAPercentage = 1.0f;
-                return;
-            }
-
-            // Check if in inner bounds
-            if (temperature >= minInner && temperature < maxInner) {
-                // In inner bounds - only one biome is present here
-                toUpdate.hasOverlap = false;
-                toUpdate.biomeA = biomesOrder[i];
-                toUpdate.biomeAPercentage = 1.0f;
-                return;
-            }
-
-            // Check if in outer bounds
-            if (temperature >= minOuter && temperature < maxOuter) {
-                // Check if in min outer bound
-                if (temperature < minInner) {
-                    toUpdate.hasOverlap = true;
-
-                    // Define biomes
-                    toUpdate.biomeA = biomesOrder[i - 1];
-                    toUpdate.biomeB = biomesOrder[i];
-
-                    // Define percentages
-                    final float range = minInner - minOuter;
-                    // minOuter <= temperature < minInner
-                    temperature -= minOuter; // 0 <= temperature < range
-                    temperature /= range; // 0 <= temperature < 1
-
-                    // Biome A goes to 0.0 as temperature goes to 1.0
-                    // Biome B goes to 1.0 as temperature goes to 1.0
-                    toUpdate.biomeAPercentage = 1.0f - (float) temperature;
-                    toUpdate.biomeBPercentage = (float) temperature;
-
-                    return;
-                }
-
-                // Check if in max outer bound
-                if (temperature >= maxInner) {
-                    toUpdate.hasOverlap = true;
-
-                    // Define biomes
-                    toUpdate.biomeA = biomesOrder[i];
-                    toUpdate.biomeB = biomesOrder[i + 1];
-
-                    // Define percentages
-                    final float range = maxOuter - maxInner;
-                    // maxInner <= temperature < maxOuter
-                    temperature -= maxInner; // 0 <= temperature < range
-                    temperature /= range; // 0 <= temperature < 1
-
-                    // Biome A goes to 0.0 as temperature goes to 1.0
-                    // Biome B goes to 1.0 as temperature goes to 1.0
-                    toUpdate.biomeAPercentage = 1.0f - (float) temperature;
-                    toUpdate.biomeBPercentage = (float) temperature;
-
-                    return;
-                }
-            }
-        }
-
-        // We should never get here!
-        toUpdate.hasOverlap = false;
-        toUpdate.biomeA = Biomes.NETHER_NETHER;
-        toUpdate.biomeAPercentage = 1.0f;
-        return;
-    }
-
     public static Biome[] allBiomes() {
-        return biomesOrder;
+        return BIOMES_ORDER;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java
index b71fd7301..1f0a50ced 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderOverworld.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.biome.provider;
 
 import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.biome.data.BiomeRange;
@@ -8,6 +9,7 @@ import net.minecraft.core.world.biome.data.BiomeRangeMap;
 import net.minecraft.core.world.noise.FractalNoise2D;
 import net.minecraft.core.world.noise.SimplexNoise;
 import net.minecraft.core.world.type.WorldType;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Set;
 
@@ -41,12 +43,11 @@ public final class BiomeProviderOverworld
     private double noiseZScale = 0.25;
     private double noiseLacunarity = 1.0;
 
-    private final WorldType worldType;
-
-    public BiomeProviderOverworld(long seed, WorldType worldType)
+    public BiomeProviderOverworld(final @NotNull World world)
     {
-        this.worldType = worldType;
+        super(world);
 
+        final long seed = world.getRandomSeed();
         this.temperatureMap = new FractalNoise2D<>(SimplexNoise.genOctaves(seed * 9871, 4));
         this.humidityMap = new FractalNoise2D<>(SimplexNoise.genOctaves(seed * 39811, 4));
         this.varietyMap = new FractalNoise2D<>(SimplexNoise.genOctaves(seed, 4));
@@ -115,7 +116,7 @@ public final class BiomeProviderOverworld
 
                 for (int dy = 0; dy < ySize; dy++)
                 {
-                    double altitude = worldType.getYPercentage((y + dy) << 3);
+                    double altitude = world.getWorldType().getYPercentage(world, (y + dy) << 3);
                     biomes[dy * xSize * zSize + dz * xSize + dx] = lookupBiome(temperature, humidity, altitude, variety);
                 }
             }
@@ -254,7 +255,7 @@ public final class BiomeProviderOverworld
                 {
                     double temperature = MathHelper.clamp(temperatures[dx * zSize + dz], 0.0, 1.0);
                     double humidity = MathHelper.clamp(humidities[dx * zSize + dz], 0.0, 1.0);
-                    double altitude = MathHelper.clamp(worldType.getYPercentage((y + dy) << 3), 0.0, 1.0);
+                    double altitude = MathHelper.clamp(this.world.getWorldType().getYPercentage(this.world, (y + dy) << 3), 0.0, 1.0);
                     double variety = MathHelper.clamp(varieties[dx * zSize + dz], 0.0, 1.0);
                     Biome biome = lookupBiome(temperature, humidity, altitude, variety);
                     Set<BiomeRange> ranges = brm.getRanges(biome);
@@ -378,15 +379,12 @@ public final class BiomeProviderOverworld
         brm.addRange(Biomes.OVERWORLD_DESERT,
                 new BiomeRange(0.85, 1.0, 0.0, 0.01, 0.0, 1.0, 0.0, 1.0)
         );
-
         brm.addRange(Biomes.OVERWORLD_OUTBACK,
                 new BiomeRange(0.75, 0.9, 0.0, 0.2, 0.0, 1.0, 0.0, 0.95)
         );
         brm.addRange(Biomes.OVERWORLD_OUTBACK_GRASSY,
                 new BiomeRange(0.75, 0.9, 0.0, 0.2, 0.0, 1.0, 0.95, 1.0)
         );
-
-
         brm.addRange(Biomes.OVERWORLD_CAATINGA,
                 new BiomeRange(0.9, 1.0, 0.01, 0.2, 0.0, 1.0, 0.1, 1.0)
         );
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderSingleBiome.java b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderSingleBiome.java
index eb38c7ca1..d95501a76 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderSingleBiome.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/provider/BiomeProviderSingleBiome.java
@@ -1,6 +1,8 @@
 package net.minecraft.core.world.biome.provider;
 
+import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Arrays;
 
@@ -12,8 +14,10 @@ public class BiomeProviderSingleBiome
     private final double defaultHumidity;
     private final double defaultVariety;
 
-    public BiomeProviderSingleBiome(Biome defaultBiome, double defaultTemperature, double defaultHumidity, double defaultVariety)
+    public BiomeProviderSingleBiome(final @NotNull World world, Biome defaultBiome, double defaultTemperature, double defaultHumidity, double defaultVariety)
     {
+        super(world);
+
         this.defaultBiome = defaultBiome;
         this.defaultTemperature = defaultTemperature;
         this.defaultHumidity = defaultHumidity;
diff --git a/game/core/src/main/java/net/minecraft/core/world/config/season/SeasonConfigBuilder.java b/game/core/src/main/java/net/minecraft/core/world/config/season/SeasonConfigBuilder.java
index 89f9ff7b4..02d0e1721 100644
--- a/game/core/src/main/java/net/minecraft/core/world/config/season/SeasonConfigBuilder.java
+++ b/game/core/src/main/java/net/minecraft/core/world/config/season/SeasonConfigBuilder.java
@@ -4,6 +4,7 @@ import it.unimi.dsi.fastutil.objects.Object2IntArrayMap;
 import it.unimi.dsi.fastutil.objects.Object2IntMap;
 import net.minecraft.core.world.season.Season;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.ArrayList;
 import java.util.List;
@@ -19,7 +20,7 @@ public class SeasonConfigBuilder
     private Type type = null;
     private List<Season> seasons = null;
     private Object2IntMap<Season> seasonLengthMap = null;
-    private Season singleSeason = null;
+    private @Nullable Season singleSeason = null;
 
     protected SeasonConfigBuilder() { }
 
@@ -39,7 +40,7 @@ public class SeasonConfigBuilder
         }
     }
 
-    public @NotNull SeasonConfigBuilder withSingleSeason(final Season season)
+    public @NotNull SeasonConfigBuilder withSingleSeason(final @Nullable Season season)
     {
         this.type = Type.SINGLE;
         this.seasons = null;
